#!/bin/bash
# Автоматический конфигуратор ядра

# 1. Путь к исходным текстам ядра
KERNEL_SRC_PATH=/usr/src/linux

# 2. pDir pDirOut
pDir=`pwd`
pDirOut="$pDir"/kernel_out
if [ ! -e "$pDirOut" ]; then mkdir "$pDirOut" ; fi

# 3. Конфиг .config "всё модулями"
cd "$KERNEL_SRC_PATH"
make O="$pDirOut" allmodconfig

# 4. Собираем все Makefile-ы в один Mak.tmp
find -name "Makefile" -exec cat '{}' >> "$pDir"/Mak.tmp \;


