#!/bin/sh

#Создаем объектный файл
gcc -Wall -g -c -o libhello-static.o libhello.c && \
#Создаем статическую библиотеку
ar rcs libhello-static.a libhello-static.o && \
#Если обладаете правами суперпользователя, то можно выполнить
#cp libhello-static.a /usr/local/lib/
#Иначе оставляем статическую библиотеку в текущей директории
#Создаем объектный файл
gcc -Wall -g -c demo_use.c -o demo_use.o && \
#Создаем исполняемый файл
#-L. - этот параметр указывает компилятору, что библиотеку следует искать в текущей директории.
#-lhello-static - этот параметр указывает компилятору, что библиотека помещается в файле
#libhello-static.расширение (.a, .o, .so).
gcc -g -o demo_use_static demo_use.o -L. -lhello-static && \
#Выполнение исполняемого файла
./demo_use_static
